# kame2/kame-dat/category/user/lib/user_.pl

$CMD_DISPATCH{'show_user_new'}  = \&show_index;
$CMD_DISPATCH{'show_user_new'}  = \&show_user_new;
$CMD_DISPATCH{'user_add'}       = \&user_add;
$SKEL_FUNC{'user_index_visitor'}   = \&skel_func_user_show_index_visitor;
$SKEL_FUNC{'user_index_user'}      = \&skel_func_user_show_index_user;
$SKEL_FUNC{'user_index_user_new'}  = \&skel_func_user_show_index_user_new;
$SKEL_FUNC{'user_index_user_edit'} = \&skel_func_user_show_index_user_edit;
$SKEL_FUNC{'user_index_editor'}  = \&skel_func_user_show_index_editor;
$SKEL_FUNC{'user_index_admin'}   = \&skel_func_user_show_index_admin;

$CMD_DISPATCH{'show_user_pref_edit'} = \&show_user_pref_edit;
$CMD_DISPATCH{'user_pref_edit'}      = \&user_pref_edit;

$CMD_DISPATCH{'show_user_password'} = \&show_user_password;
$CMD_DISPATCH{'user_password'}      = \&user_password;


sub show_index{
  my $user_name = $SCHEME->{'_USER'}->{'user_name'};
  my $scheme = $SCHEME->{'_SCHEME'}->{'scheme'};

  $scheme =~ /^user\/([^\/]+)/;
  my $user_scheme = $1;

#print STDERR "user_.pl:show_index \$user_name=$user_name,\$scheme=$scheme,\$user_scheme=$user_scheme\n";


  if ($user_scheme eq $user_name){
#    print STDERR "user_.pl:show_index: 桼̾ȥ桼बƱ = \n";
    ;
  } elsif ($user_scheme eq ""){
#    print STDERR "user_.pl:show_index: 桼ब = USER_TOP\n";
    ;
  } else {
#    print STDERR "user_.pl:show_index: 桼̾ȥ桼ब㤦 = ͤ USER_HOME\n";
    $user_name = "";
  }

  if ($scheme eq 'user'){
#print STDERR "user_.pl:show_index \$scheme=$scheme: USER_TOP\n";
    if ($user_name){
#print STDERR "user_.pl:show_index \$user_name=$user_name: REDIRECT USER_HOME\n";
      &redirect_pathinfo("/user/$user_name/");
    } else {
#print STDERR "user_.pl:show_index \$user_name=$user_name: USER_TOP OK\n";
      &show__skelfile('index.html');
    }
  } else {
#print STDERR "user_.pl:show_index \$scheme=$scheme: USER_HOME\n";
    if ($user_name){
#print STDERR "user_.pl:show_index \$user_name=$user_name: USER_HOME OK\n";
      &show__skelfile('index.html');
    } else {
      &redirect_pathinfo("/user/");
#print STDERR "user_.pl:show_index \$user_name=$user_name: REDIRECT USER_TOP\n";
    }
  }

}

sub skel_func_user_show_index_visitor{
  my $user_name = &user_require;

  if ($user_name){
    return "";
  } else {
    my $file_path = &scheme_findfile('skel', 'user_index_visitor.htm');
    my $skel_str = &skel_open($file_path);
    return $skel_str;
  }
}

sub skel_func_user_show_index_user{
  my $user_name = &user_require;

  if ($user_name){
    my $file_path = &scheme_findfile('skel', 'user_index_user.htm');
    my $skel_str = &skel_open($file_path);
    return $skel_str;
  } else {
    return "";
  }
}

sub skel_func_user_show_index_editor{
  my $user_name = &user_require;

  if ($user_name){
    my $user_dir = &get_homedir($user_name);
    my $user_db1_path = "$user_dir/data/user.db1";
    my $user_db1 = &db1_load($user_db1_path);

    if ($user_db1->{'role_editor'}){
      my $file_path = &scheme_findfile('skel', 'user_index_editor.htm');
      my $skel_str = &skel_open($file_path);
      return $skel_str;
    } else {
      return "";
    }
  } else {
    return "";
  }
}

# skel_func_user_show_index_user_new 
# skel_func_user_show_index_user_edit ζ̥롼
sub _skel_func_user_show_index_user_{
  my $type = shift;
#print STDERR "_skel_func_user_show_index_user_($type)\n";

  my $user_name = &user_require;

  if ($user_name){
    my $user_dir = &get_homedir($user_name);
    my $user_db1_path = "$user_dir/data/user.db1";
    my $user_db1 = &db1_load($user_db1_path);

    if ($user_db1->{'role_editor'}){
      my $ret = "";
      my $key;
      my $inc_file_path;
      my $inc_file_name;
      $ret .= "<ol>\n";
      foreach $key (split(',', $user_db1->{'role_editor'})){
	$inc_file_name = "user_" . $type . "_" . $key . ".htm";
	$inc_file_path = &scheme_findfile('skel', $inc_file_name);
	$ret .= &skel_open($inc_file_path);
      }
      $ret .= "</ol>\n";
      return $ret;
    } else {
      return "";
    }
  } else {
    return "";
  }

}

sub skel_func_user_show_index_user_new{
  &_skel_func_user_show_index_user_('new');
}

sub skel_func_user_show_index_user_edit{
  &_skel_func_user_show_index_user_('edit');
}

sub skel_func_user_show_index_admin{
  my $user_name = &user_require;

  if ($user_name){
    my $user_dir = &get_homedir($user_name);
    my $user_db1_path = "$user_dir/data/user.db1";
    my $user_db1 = &db1_load($user_db1_path);

    if ($user_db1->{'role_admin'}){
      my $file_path = &scheme_findfile('skel', 'user_index_admin.htm');
      my $skel_str = &skel_open($file_path);
      return $skel_str;
    } else {
      return "";
    }
  } else {
    return "";
  }
}


sub show_user_new{
  &show__skelfile('user_new.html');
}

sub user_add{
#  print STDERR "user_add\n";

  &show_user_add_missing("桼̾") unless ($PARAM->{'user_name'});
  &show_user_add_missing("ѥ") unless ($PARAM->{'pass1'});
  &show_user_add_missing("ѥɤγǧ") unless ($PARAM->{'pass2'});
  &show_user_add_missing("ϥɥ̾") unless ($PARAM->{'handle'});
  &show_user_add_passdiff unless ($PARAM->{'pass1'} eq $PARAM->{'pass2'});

  my $user_directory = &get_homedir($PARAM->{'user_name'});

  &show_user_add_sameuser("$PARAM->{'user_name'}") if (-d $user_directory);

  &make_directory("$user_directory");
  &make_directory("$user_directory/data");

  my $user_db1 = {};
  $user_db1->{'user_name'} = $PARAM->{'user_name'};
  $user_db1->{'pass_crypted'} = crypt($PARAM->{'pass1'}, &gen_salt);
  $user_db1->{'handle'} = $PARAM->{'handle'};
  $user_db1->{'mail'} = &sanitize_mailaddr($PARAM->{'mail'});

  &db1_write($user_db1, "$user_directory/data/user.db1");

  &_user_add_mail_notify($user_db1, $SCHEME->{'_CONFIG'}->{'admin_mail'});
  &_user_add_mail_notify($user_db1, $user_db1->{'mail'});

  my $key;
  foreach $key (keys %$user_db1){
    $SKEL->{$key} = &sanitize_nohtml($user_db1->{$key});
  }

  &show__skelfile('user_add.html');
}


sub show_user_add_missing{
  my $field = shift;
  $SKEL->{'message'} = 
    "ɬܥǡ <strong>$field</strong> ϤƤޤ";
  &show__skelfile('user_add_error.html');
}

sub show_user_add_passdiff{
  $SKEL->{'message'} = "2ĤΥѥϤۤʤäƤޤ";
  &show__skelfile('user_add_error.html');
}

sub show_user_add_sameuser{
  my $user_name = shift;
  $SKEL->{'message'} =
    "ǰǤΥ桼̾($user_name)ϤǤ˻ѤƤޤ";
  &show__skelfile('user_add_error.html');
}

sub show_user_pref_edit{
#  print STDERR "show_user_pref_edit\n";

  my $user_name = &user_require;
  &show__skelfile('user_required.html') unless $user_name;

  my $user_dir = &get_homedir($user_name);
  my $user_db1_path = "$user_dir/data/user.db1";
  my $user_db1 = &db1_load($user_db1_path);

  my $key;
  foreach $key (keys %$user_db1){
    $SKEL->{$key} = &sanitize_nohtml($user_db1->{$key});
  }

  &show__skelfile('user_pref_edit.html');
}


sub user_pref_edit{
#  print STDERR "user_pref_edit\n";

  my $user_name = &user_require;
  &show__sielfile('user_required.html') unless $user_name;

  my $user_dir = &get_homedir($user_name);
  my $user_db1_path = "$user_dir/data/user.db1";
  my $user_db1 = &db1_load($user_db1_path, 1);

  $user_db1->{'handle'} = $PARAM->{'handle'};
  $user_db1->{'mail'} = &sanitize_mailaddr($PARAM->{'mail'});

  &db1_write($user_db1, $user_db1_path);

  my $key;
  foreach $key (keys %$user_db1){
    $SKEL->{$key} = &sanitize_nohtml($user_db1->{$key});
  }

  &_user_pref_mail_notify($user_db1, $SCHEME->{'_CONFIG'}->{'admin_mail'});
  &_user_pref_mail_notify($user_db1, $user_db1->{'mail'});

  &show__skelfile('user_pref_edit.html');
}


sub show_user_password{
#  print STDERR "show_user_password\n";

  my $user_name = &user_require;
  &show__sielfile('user_required.html') unless $user_name;

  my $user_dir = &get_homedir($user_name);
  my $user_db1_path = "$user_dir/data/user.db1";
  my $user_db1 = &db1_load($user_db1_path);

  my $key;
  foreach $key (keys %$user_db1){
    $SKEL->{$key} = &sanitize_nohtml($user_db1->{$key});
  }

  &show__skelfile('user_password.html');
}

sub user_password{
#  print STDERR "user_password\n";

  my $user_name = &user_require;
  &show__skelfile('user_required.html') unless $user_name;

  my $user_dir = &get_homedir($user_name);
  my $user_db1_path = "$user_dir/data/user.db1";
  my $user_db1 = &db1_load($user_db1_path, 1);

  my $old_crypte = crypt($PARAM->{'pass1'}, $user_db1->{'pass_crypted'});
  if ($old_crypte ne $user_db1->{'pass_crypted'}){
    show__skelfile('user_required.html');
  }

  &show_user_add_passdiff unless ($PARAM->{'pass1'} eq $PARAM->{'pass2'});

  $user_db1->{'pass_crypted'} = crypt($PARAM->{'pass1'}, &gen_salt);

  &db1_write($user_db1, $user_db1_path);

  &_user_password_mail_notify($user_db1,$SCHEME->{'_CONFIG'}->{'admin_mail'});
  &_user_password_mail_notify($user_db1,$user_db1->{'mail'});

  $SKEL->{'user_name'} = &sanitize_nohtml($user_db1->{'user_name'});

  &show__skelfile('user_password_done.html');

}

sub user_require{

  my $user_name = $SCHEME->{'_USER'}->{'user_name'};
  my $scheme = $SCHEME->{'_SCHEME'}->{'scheme'};

  my @schemes = split('/', $scheme);
  my $user_scheme = pop(@schemes);

  unless($user_name){
#    print STDERR "user_require: \$user_name=$user_name\n";
#    &show__skelfile('user_required.html');
    return 0;
    exit;
  }
  unless ($user_name eq $user_scheme){
#    print STDERR "user_require: \$user_name=$user_name, \$user_scheme=$user_scheme\n";
#    &show__skelfile('user_required.html');
    return 0;
    exit;
  }

  return $user_name;
}

sub _user_add_mail_notify{
  my ($user_db1, $to) = @_;

  return unless $to;

  my $subject = "USER ADD (KAME-Board)";
  my $content = &kame_mail_access_info;

  $content .= <<"TEXT";
桼ɲäޤ

桼̾    : $user_db1->{'user_name'}
ϥɥ    : $user_db1->{'handle'}
᡼륢ɥ쥹 : $user_db1->{'mail'}
TEXT

  $mail{'To'} = $to;
  $mail{'Subject'} = $subject;
  $mail{'Body'} = $content;

  &kame_sendmail(\%mail);
}



sub _user_password_mail_notify{
  my ($user_db1, $to) = @_;

  return unless $to;

  my $subject = "PASSWORD Changed (KAME-Board)";
  my $content = &kame_mail_access_info;

  $content =<<"TEXT";
ѥɤѹޤ
TEXT

  $mail{'To'} = $to;
  $mail{'Subject'} = $subject;
  $mail{'Body'} = $content;

  &kame_sendmail(\%mail);
}

sub _user_pref_mail_notify{
  my ($user_db1, $to) = @_;

  return unless $to;

  my $subject = "User Pref. is Changed (KAME-Board)";
  my $content = &kame_mail_access_info;

  $content =<<"TEXT";
桼󤬹ޤ

桼̾: $user_db1->{'user_name'}
ϥɥ: $user_db1->{'handle'};
᡼륢ɥ쥹: $user_db1->{'mail'}
TEXT

  $mail{'To'} = $to;
  $mail{'Subject'} = $subject;
  $mail{'Body'} = $content;

  &kame_sendmail(\%mail);
}



1;


