# kame2/kame-dat/package/nikki/skel_func_latest_index.pl

# $Source: /home/nkon2/public_html/kame2/kame-dat/package/nikki/RCS/skel_func_latest_index.pl,v $
# $Id: skel_func_latest_index.pl,v 1.1 2003/06/01 10:00:37 nkon Exp $
# $Log: skel_func_latest_index.pl,v $
# Revision 1.1  2003/06/01 10:00:37  nkon
# Initial revision
#

$SKEL_FUNC{'latest_index'} = \&skel_func_latest_index;
$SKEL_FUNC{'rest_index'} = \&skel_func_rest_index;
$SKEL_FUNC{'editor_index'} = \&skel_func_editor_index;

sub skel_func_latest_index{

  my $latest_num = $SCHEME->{'_CONFIG'}->{'latest_num'};
  # latest_num kame/config/config.db1 
  unless ($latest_num){
    $latest_num = 5;
#    print STDERR "Can't get \$latest_num from config/config.db1\n";
#    print STDERR "Set Default value 5\n";
  }

  return &_latest_index('index_long.htm', 0, $latest_num-1);
}

sub skel_func_rest_index{
  my $latest_num = $SCHEME->{'_CONFIG'}->{'latest_num'};
  # latest_num kame/config/config.db1 
  unless ($latest_num){
    $latest_num = 5;
#    print STDERR "Can't get \$latest_num from config/config.db1\n";
#    print STDERR "Set Default value 5\n";
  }
  return &_latest_index('index_short.htm', $latest_num, 100000);
}

sub skel_func_editor_index{
  return &_latest_index('index_editor_long.htm', 0, 100000);
}


##################################

sub _latest_index{
  my ($skel_file_name, $from, $num) = @_;

#  print STDERR "skel_func_latest_index.pl:_latest_index($skel_file_name, $from, $num)\n;

  my $skel_path = &scheme_findfile('skel', $skel_file_name);
  my $skel_str  = &skel_open($skel_path);

  my $index_db_file = &_get_index_db_path;

#  print STDERR "skel_func_latest_index: \$index_db_file=$index_db_file\n";

  return unless (-f $index_db_file);


  # sort ǻȤΤ local
  local($index_db) = &db_load($index_db_file, '_id', 0);

  my @db_key = keys %$index_db;
  @db_key = sort _sort_db_latest @db_key;

  my $id;
  my $i    = 0;
  my $out  = 0;
  my $pass = 0;
  my $scheme_global = $SCHEME->{'_SCHEME'}->{'scheme'};
  my $ret;

  # 
  while(1){
    last if ($pass >= $from);
    $id = $db_key[$i];
    last unless $id;
    if ($index_db->{$id}->{'_scheme'} =~ $scheme_global){
      $pass++;
    }
    $i++;
  } # while(1) 

  # 
  while(1){
    last if ($out >= $num);
    $id = $db_key[$i];
    last unless $id;
    if ($index_db->{$id}->{'_scheme'} =~ $scheme_global){
      $out++;
    } else {
      $i++;
      next;
    }
    $ret .= &_index_item($skel_str, $index_db->{$id}, $scheme_global);
    $i++;
  } # while(1) 

  return $ret;
}

sub _index_item{
  my ($skel_str, $item_db1, $scheme_global) = @_;

  # : ХѿɽŪѹ
  local($SCHEME);
  local($DATA_DEF);
  local($SKEL);
  $DATA_DEF = undef;

  my $scheme_local = $item_db1->{'_scheme'};
  my $format_local = $item_db1->{'_format'};

  &scheme_config_load($scheme_local);
  &convert_internal_2_html($item_db1, $scheme_local, $format_local);

# print STDERR "\$scheme_local=$scheme_local, \$scheme_global=$scheme_global\n";

  if ($scheme_local eq $scheme_global){
    $SKEL->{'_ref_category'} = "";
  } else {
    $SKEL->{'_ref_category'} = $SKEL->{'_category'} . "/";
  }

  return &skel_subst($skel_str, $skel_local);
}

sub _sort_db_latest{
  $index_db->{$b}->{'_id'} <=> $index_db->{$a}->{'_id'};
}

1;

