
# $Source: /home/nkon2/public_html/kame2/kame-dat/category/zukan/lib/RCS/skel_func_zukan_index.pl,v $
# $Id: skel_func_zukan_index.pl,v 1.1 2003/06/01 10:10:30 nkon Exp $
# $Log: skel_func_zukan_index.pl,v $
# Revision 1.1  2003/06/01 10:10:30  nkon
# Initial revision
#

$SKEL_FUNC{'zukan_index'} = \&skel_func_zukan_index;
$SKEL_FUNC{'zukan_index_child'} = \&skel_func_zukan_index_child;
$SKEL_FUNC{'editor_index'} = \&skel_func_editor_index;

# Υƥ°Τ򥤥ǥ롣
sub skel_func_zukan_index{
  return &_index('index_long.htm', '1');
}

# Υƥʲ°Τ򥤥ǥ롣
sub skel_func_zukan_index_child{
  return &_index('index_short.htm', '0');
}

# Υƥ°ΤԽѥƥץ졼Ȥǥǥ롣
sub skel_func_editor_index{
  return &_index('index_editor_long.htm', '1');
}


##################################

sub _index{
  my ($skel_file_name, $match_strict) = @_;

  my $skel_path = &scheme_findfile('skel', $skel_file_name);
  my $skel_str  = &skel_open($skel_path);

  my $index_db_file = &_get_index_db_path;

#  print STDERR "skel_func_latest_index: \$index_db_file=$index_db_file\n";

  return unless (-f $index_db_file);

  # sort ǻȤΤ local
  local($index_db) = &db_load($index_db_file, '_id', 0);

  my @db_key = keys %$index_db;
  @db_key = sort _sort_db_dict @db_key;

  my $id;
  my $i    = 0;
  my $scheme_global = $SCHEME->{'_SCHEME'}->{'scheme'};
  my $ret;

  # 
  for($i = 0; $i < scalar(@db_key); $i++){
    $id = $db_key[$i];
    last unless $id;
    if (($match_strict == 1) and
	($index_db->{$id}->{'_scheme'} eq $scheme_global)){
      $ret .= &_index_item($skel_str, $index_db->{$id}, $scheme_global);
    } elsif (($match_strict == 0) and
	     ($index_db->{$id}->{'_scheme'} =~ /^$scheme_global/)){
      $ret .= &_index_item($skel_str, $index_db->{$id}, $scheme_global);
    }
  }

  return $ret;
}

sub _index_item{
  my ($skel_str, $item_db1, $scheme_global) = @_;

  # : ХѿɽŪѹ
  local($SCHEME);
  local($DATA_DEF);
  local($SKEL);
  $DATA_DEF = undef;

  my $scheme_local = $item_db1->{'_scheme'};
  my $format_local = $item_db1->{'_format'};

  &scheme_config_load($scheme_local);
  &convert_internal_2_html($item_db1, $scheme_local, $format_local);

# print STDERR "\$scheme_local=$scheme_local, \$scheme_global=$scheme_global\n";

  if ($scheme_local eq $scheme_global){
    $SKEL->{'_ref_category'} = "";
  } else {
    $SKEL->{'_ref_category'} = $SKEL->{'_category'} . "/";
  }

  return &skel_subst($skel_str, $skel_local);
}

sub _sort_db_dict{
  $index_db->{$b}->{'jname'} <=> $index_db->{$a}->{'jname'};
}

1;

