# kame-dat/lib/skel_func_skeltest.pl
# <skel_func skeltest>
# $SKEL-> ɽ롣

$SKEL_FUNC{'skeltest'} = \&skel_func_skeltest;
$SKEL_FUNC{'configtest'} = \&skel_func_configtest;

sub skel_func_skeltest{

  return if ($ENV{'SERVER_NAME'} ne 'localhost.localdomain');

  my $key;
  my $str;

  $str = <<"HTML";
<table border>
<tr><th colspan="2">&lt;skel_func skeltest&gt;kame-dat/lib/skel_func_skeltest.pl:sub skel_func_skeltest</th></tr>
HTML

  my $sanitized;
  foreach $key (keys %$SKEL){
    $sanitized = &sanitize_nohtml($SKEL->{$key});
    $str .= "<tr><td>$key</td><td>$sanitized</td></tr>\n";
  }

  $str .= "</table>\n";
  return $str;

}

sub skel_func_configtest{

  return if ($ENV{'SERVER_NAME'} ne 'localhost.localdomain');

  my $key;
  my $str;

  $str = <<"HTML";
<table border>
<tr><th colspan="2">&lt;skel_func configtest&gt;kame-dat/lib/skel_func_skeltest.pl:sub skel_func_configtest</th></tr>
HTML

  my $sanitized;
  foreach $key (keys %{$SCHEME->{'_CONFIG'}}){
    $sanitized = &sanitize_nohtml($SCHEME->{'_CONFIG'}->{$key});
    $str .= "<tr><td>$key</td><td>$sanitized</td></tr>\n";
  }

  $str .= "</table>\n";
  return $str;

}


1;

