#!/usr/bin/perl -T

use Time::Local;

#############################################################
# 

# ǡǥ쥯ȥΥѥ / դʤ
$DATA_DIR = "./kame-dat";

# kameboard.cgi Τǥ쥯ȥΥեѥ
$CGI_DIR = "/home/nkon2/public_html/kame2";

# ᡼ȤΥǥեȥɥ쥹(꤬Ĥʤ˻Ȥ)
$DEFAULT_MAIL = 'nkon@bf.wakwak.com';

# 桼ѹ 
#############################################################

#############################################################
# 

$DEBUG = 1;

$LIB_DIR = "$DATA_DIR/syslib";
unshift(@INC, $LIB_DIR);
require 'jcode.pl';
require 'auth_.pl';
require 'parse_.pl';
require 'cookie_.pl';
require 'pathinfo_.pl';
require 'db_.pl';
require 'scheme_.pl';
require 'skel_.pl';
require 'show_.pl';
require 'sanitize_.pl';
require 'util.pl';

umask(0);        # и¤ư뤿 umask 򳰤Ƥ
# &access_log;

# PATH_INFO 
# // -> /  쥯
if (($ENV{'PATH_INFO'} =~ /\/\//) and
   ($ENV{'REQUEST_METHOD'} eq "GET") and
   ($ENV{'QUERY_STRING'} eq "") ){
  $new_pathinfo = $ENV{'PATH_INFO'};
  1 while($new_pathinfo =~ s/\/\//\//g);
  &redirect_pathinfo($new_pathinfo);
  exit;
}

# kameboard.cgi λkameboard.cgi/ ˥쥯
if(($ENV{'PATH_INFO'} eq "") and
   ($ENV{'REQUEST_METHOD'} eq "GET") and
   ($ENV{'QUERY_STRING'} eq "") ){
  &redirect(&get_kame_url);
  exit;
}

# kameboard.cgi/aaa/bbb λkameboard.cgi/aaa/bbb/ ˥쥯
if (($ENV{'PATH_INFO'} =~ /\/[^.\/]+$/) and
   ($ENV{'REQUEST_METHOD'} eq "GET") and
   ($ENV{'QUERY_STRING'} eq "") ){
  $new_pathinfo = $ENV{'PATH_INFO'} . "/";
  &redirect_pathinfo($new_pathinfo);
  exit;
}


&pathinfo_parse($ENV{'PATH_INFO'});

unless (&scheme_ok()){
  &show_not_found;
}

&cookie_parse($ENV{'HTTP_COOKIE'});

&auth_user;

&scheme_config_load;

if ($SCHEME->{'_CONFIG'}->{'size_limit'}){
  &parse_input({'size_limit' => $SCHEME->{'_CONFIG'}->{'size_limit'}});
}else {
  &parse_input;
}

# &parse_copy_to_skel;

#print STDERR "\$PARAM->{'_CMD'} = $PARAM->{'_CMD'}\n";

$SKEL->{'_KAME_CGI_SCHEME'}  = &get_kame_cgi_scheme;
$SKEL->{'_THIS_PATH_INFO'} = &get_this_path_info;
$SKEL->{'_SCRIPT_URL'}  = &get_script_url;
$SKEL->{'_KAME_TOP'}  = &get_kame_top;
$SKEL->{'_KAME_URL'}  = &get_kame_url;

$CMD_DISPATCH{'show_index'} = \&show_index;
$CMD_DISPATCH{'show_article'} = \&show_article;
$CMD_DISPATCH{'show_article_file'} = \&show_article_file;
$CMD_DISPATCH{'show_not_found'} = \&show_not_found;
$CMD_DISPATCH{'show__file'} = \&show__file;


#&debug_dump_env;
#&scheme_debug_dump;
#&parse_debug_dump;
#&skel_debug_dump;

# print STDERR "dispatch_table \$PARAM->{'_CMD'}=$PARAM->{'_CMD'}\n";

if ($CMD_DISPATCH{$PARAM->{'_CMD'}}){
  if ((
       ($PARAM->{'_CMD'} ne 'show__file')
       and
       ($PARAM->{'_CMD'} ne 'show_article_file')
      )
      and ($SCHEME->{'_USER'}->{'user_name'})
     ){
    # åκ
    &auth_set_cookie($SCHEME->{'_USER'}->{'user_name'});
  }
  &{$CMD_DISPATCH{$PARAM->{'_CMD'}}};
} else {
  &show_not_found;
}


exit;

sub get_kame_url{
  return "http://" . $ENV{'SERVER_NAME'} . $ENV{'SCRIPT_NAME'} . "/";
}

sub get_kame_top{
  return $ENV{'SCRIPT_NAME'};
}

sub get_kame_cgi{
  return $ENV{'SCRIPT_NAME'} . "/";
}

sub get_kame_cgi_scheme{
  my $ret;
  my $scheme = $PARAM->{'_SCHEME'};
  if ($scheme){
    $scheme .= "/";
  }

  return $ENV{'SCRIPT_NAME'} . "/" . $scheme;
}


sub get_kame_base{
  my $ret = "http://" . $ENV{'SERVER_NAME'} . $ENV{'SCRIPT_NAME'};
  $ret .= '/' . $PARAM->{'_SCHEME'} . '/';
  return $ret;
}

sub get_script_url{
  return $ENV{'SCRIPT_NAME'};
}


sub get_this_path_info{
  my $ret = $ENV{'PATH_INFO'};
  if ($ENV{'QUERY_STRING'}){
    $ret .= "?" . $ENV{'QUERY_STRING'};
  }
  return $ret;
}
