#!/usr/bin/perl
$DEBUG =1;
$EXEC = 1;
$PWD = "/home/nkon/public_html/kame2";
$target_dir = "/home/nkon/public_html/kame2-installed/20030601";

use Cwd;
use File::Path;
use File::Copy;

umask(0);

chdir($PWD);
mkpath($target_dir, 1, 0755);
print "make directory $target_dir\n";

open(FIND, "find . -print | ");
@file_list = <FIND>;
close(FIND);


foreach $file (@file_list){
  chomp($file);

  $file =~ /^\.\/(.*)/;
  $file = $1;

  next unless ($file);

  if ($file =~ /~$/){
    print  "$file is backup file => not copy\n" if $DEBUG;
    next;
  }
  if ($file =~ /^out/){
    print  "$file => out/ directory is not copy\n" if $DEBUG;
    next;
  }
  if ($file =~ /\/data\//){
    print  "$file is data file => not copy\n" if $DEBUG;
    next;
  }
  if ($file =~ /\/RCS/){
    print "$file is RCS directory => not copy\n" if $DEBUG;
    next;
  }
  if ($file =~ /\/.xvpics/){
    print "$file is .xvpics directory => not copy\n" if $DEBUG;
    next;
  }

  print  "Install $file\n" if $DEBUG;
  $file =~ /([^\/]+)$/;
  $body_name = $1;
  print  "\$body_name=$body_name\n" if $DEBUG;

  if (-d $file){
    print  "$file is directory\n" if $DEBUG;
    $mode = (stat($file))[2];
    mkpath("$target_dir/$file", 1, $mode) if $EXEC;
   } elsif (-l $file){
    print  "$file is symlink => not copy\n" if $DEBUG;
  } else{
    print  "$file is file => copy\n" if $DEBUG;
    $mode = (stat($file))[2];
    copy($file, "$target_dir/$file");
    chmod $mode, "$target_dir/$file" if $EXEC;
    print "copy file $file => $target_dir/$file\n";
  }
}

