# kame2/kame-dat/syslib/auth_.pl

$CMD_DISPATCH{'show_login_form'}  = \&show_login_form;
$CMD_DISPATCH{'auth_user_login'}  = \&auth_user_login;
$CMD_DISPATCH{'auth_user_logout'} = \&auth_user_logout;

# $PARAM->{'user_name'}  $PARAM->{'password'} 򸫤ơ
# ʤ顢
# auth_cookie 򥻥åȤơ
# $PARAM->{'_REFERER_PATH_INFO'}֡
### å
### : $PARAM->{'password'}
sub auth_user_login{
#  print STDERR "auth_user_login\n";

  my $pass_input = $PARAM->{'password'};
  undef $PARAM->{'password'};
  undef $SKEL->{'password'};

  my $user_dir = &get_homedir($PARAM->{'user_name'});
  my $user_db1_file = "$user_dir/data/user.db1";

  unless (-r $user_db1_file){
    $SKEL->{'message'} = "桼̾Ĥޤ\n";
    &show_login_form;
    exit;
  }

  my $user_db1 = &db1_load($user_db1_file, 0);

  if ($user_db1->{'pass_crypted'} ne
      crypt($pass_input, $user_db1->{'pass_crypted'})){
    $SKEL->{'message'} = "ѥɤ㤤ޤ\n";
    &show_login_form;
    exit;
  }

#  print STDERR "KAME-Board Auth Log: login succeed \$PARAM->{'user_name'}=$PARAM->{'user_name'}\n";

  &auth_set_cookie($PARAM->{'user_name'});

  &_auth_login_mail_notify($user_db1);

  &redirect_pathinfo($PARAM->{'_REFERER_PATH_INFO'});
}

# auth_cookie õơ
# $PARAM->{'_REFERER_PATH_INFO'}֡
sub auth_user_logout{
#  print STDERR "auth_user_logout\n";

  my $cookie_str = $GET_COOKIE->{'KAME'};
  my ($user_name, $random_session) = split(':', $cookie_str, 2);
  my $user_dir = &get_homedir($user_name);
  my $session_path = "$user_dir/data/session.db1";
  unlink($session_path) if (-f $session_path);
  &cookie_delete;

  &redirect_pathinfo($PARAM->{'_REFERER_PATH_INFO'});
}


sub show_login_form{
  $SKEL->{'_REFERER_PATH_INFO'}=$PARAM->{'_REFERER_PATH_INFO'};
  &show__skelfile('login_form.html');
}

# cookie Υ桼̾ȥå󥳡ɤ桼ǧڤ򤹤롣
#  桼֤̾
# ʤ 0 ֤
sub auth_user{
  my $cookie_str = $GET_COOKIE->{'KAME'};
  my ($user_name, $random_session) = split(':', $cookie_str, 2);

#  print STDERR "auth_user \$cookie_str = $cookie_str\n";

  unless ($user_name){
    $SKEL->{'message'} = "auth_user: GET_COOKIE桼̾ޤ";
    print STDERR "$SKEL->{'message'}\n" if $DEBUG;
    return 0;
  }

  my $user_dir = &get_homedir($user_name);
  my $session_path = "$user_dir/data/session.db1";

  unless (-r $session_path){
    $SKEL->{'message'} = "å($session_path)Ĥޤ\n";
    &cookie_delete;
    print STDERR "$SKEL->{'message'}\n" if $DEBUG;
    return 0;
  }

  my $session_db1 = &db1_load($session_path, 0);

  my $now_remote_addr = $ENV{'REMOTE_ADDR'};
  my $now_time = time;
  $EXPIRE = 60*20; #åͭ = 20 ʬ

  # ǡ١˥å󤬸Ĥʤ
  unless( $session_db1 ){
    $SKEL->{'message'} = "auth_user: å󤬸Ĥޤ";
    unlink($session_path);
    &cookie_delete;
    print STDERR "$SKEL->{'message'}\n" if $DEBUG;
    return 0;
  }

  # åλڤ
  if ($session_db1->{'expire'} < $now_time){
    $SKEL->{'message'} = "auth_user: GET_COOKIEͭ¤ڤƤޤ";
    unlink($session_path);
    &cookie_delete;
    print STDERR "$SKEL->{'message'}\n" if $DEBUG;
    return 0;
  }

  # ⡼ȥɥ쥹ؤäƤ
  if ($session_db1->{'remote_addr'} ne $now_remote_addr){
    $SKEL->{'message'} = "auth_user: ⡼ȥɥ쥹ѤäƤޤ";
    unlink($session_path);
    &cookie_delete;
    print STDERR "$SKEL->{'message'}\n" if $DEBUG;
    return 0;
  }

  # äƤ
  if ($session_db1->{'random'} ne $random_session){
    $SKEL->{'message'} = "auth_user: å󥭡԰פǤ";
    unlink($session_path);
    &cookie_delete;
    print STDERR "$SKEL->{'message'}\n" if $DEBUG;
    return 0;
  }

  # $SKEL-> ˥å
  &_auth_set_user_name_to_skel($user_name);

  $SCHEME->{'_USER'}->{'user_name'} = $user_name;

#  print STDERR "KAME-Board Auth Log: auth succeed \$SCHEME->{'_USER'}->{'user_name'}=$SCHEME->{'_USER'}->{'user_name'}\n";

  return $user_name;

}

# å󥳡ɤ򿷤˥åȤ롣
sub auth_set_cookie{
  my $user_name = shift;

#  print STDERR "auth_set_cookie($user_name)\n";

  my $remote_addr = $ENV{'REMOTE_ADDR'};
  my $random_session = int(rand(65535));
  my $nowtime = time;

  $EXPIRE = 60*20; #åͭ = 20 ʬ

  $SET_COOKIE->{'KAME'} = &cookie_compose('KAME',
				      "$user_name:$random_session",
				      $nowtime + $EXPIRE,
				      $ENV{'SERVER_NAME'},
				      $ENV{'SCRIPT_NAME'} . "/");
#  print STDERR "auth_set_cookie:$user_name:$random_session\n";
#  print STDERR "auth_set_cookie:\$PARAM->{'_CMD'}=$PARAM->{'_CMD'}\n";

  my $session = {};
  $session->{'user_name'} = $user_name;
  $session->{'remote_addr'} = $remote_addr;
  $session->{'expire'} = $nowtime + $EXPIRE;
  $session->{'random'} = $random_session;

  my $user_dir = &get_homedir($user_name);
  my $session_path = "$user_dir/data/session.db1";
  &db1_write($session, $session_path);
}

sub _auth_set_user_name_to_skel{
  my $user_name = shift;

  unless ($SCHEME->{'_USER'}->{'db1'}){
    my $user_dir = &get_homedir($user_name);
    my $user_db1_path = "$user_dir/data/user.db1";
    $SCHEME->{'_USER'}->{'db1'} = &db1_load($user_db1_path, 0);
  }
  my $user_db1 = $SCHEME->{'_USER'}->{'db1'};

  $SKEL->{'_USER_HANDLE'} = $user_db1->{'handle'};
  $SKEL->{'_USER_NAME'} = $user_db1->{'user_name'};
}


# 桼̾ scheme  role ɤ user.db1 򸵤ȽǤ롣
#  1 ʤ 0 ֤
sub auth_user_role{
  my ($user_name, $scheme, $role) = @_;
#  print STDERR "auth_user_role($user_name, $scheme, $role)\n";

  unless ($SCHEME->{'_USER'}->{'db1'}){
    my $user_dir = &get_homedir($user_name);
    my $user_db1_path = "$user_dir/data/user.db1";
    $SCHEME->{'_USER'}->{'db1'} = &db1_load($user_db1_path, 0);
  }
  my $user_db1 = $SCHEME->{'_USER'}->{'db1'};

  my $key;
  foreach $key (split(',', $user_db1->{"role_$role"})){
#    print STDERR "auth_user_roke: \$key=$key, \$scheme=$scheme\n";
     if ($scheme =~ /^$key/){
       return 1;
     }
  }
  return 0;
}

sub _auth_login_mail_notify{
  my $user_db1 = shift;

  my $to   = $SCHEME->{'_CONFIG'}->{'mail_notify_to'};
  my $subject = "KAME-Board User LOGIN";
  my $content = &kame_mail_access_info;

  $content .= <<"TEXT";
󤷤桼: $user_db1->{'user_name'}
桼Υϥɥ:   $user_db1->{'handle'}
TEXT

  $mail{'To'} = $to;
  $mail{'Subject'} = $subject;
  $mail{'Body'} = $content;

  &kame_sendmail(\%mail);
}

1;

