# kame2/kame-dat/syslib/cookie_.pl

# ˡ$ENV{'HTTP_COOKIE'}Ϳȡ
# ѡ
# ϥåλ $GET_COOKIE ˥åȤ롣
sub cookie_parse{
  my $cookie = shift;
#  $cookie = $ENV{'HTTP_COOKIE'} unless $cookie;

  my $pairs;
  my $name;
  my $value;

#  print STDERR "cookie_parse: \$cookie = $cookie\n";

  foreach $pairs(split(/;/, $cookie)){
    ($name, $value) = split(/=/, $pairs);
    $value =~ s/%([0-9A-Fa-f][0-9A-Fa-f])/pack("C", hex($1))/eg;
    $GET_COOKIE->{$name} = $value;
  }
}

# ($name, $value, $expire, $domain, $path) 
#  Set-Cookie: ˥åȤʸơ
# ֤
sub cookie_compose{
  my ($name, $value, $expire, $domain, $path) = @_;
#  print STDERR "cookie_compose($name, $value, $expire, $domain, $path)\n";

  my $encoded_value = $value;
  $encoded_value =~ s/(\W)/sprintf("%%%02X", unpack("C", $1))/eg;

  my $ret;

  $ret = "$name=$encoded_value";

  if ($expire){  $ret .= ";expires=" . &cookie_time_to_str($expire);  }
  if ($domain){  $ret .= "domain=$domain";                            }
  if ($path)  {  $ret .= ";path=$path";                               }

#  print STDERR "cookie_compose = $ret\n";

  return $ret;
}


# time Ϳȡ
# Sun,1-Jan-2001 12:34:56 GMT 
# ʸɽ֤
sub cookie_time_to_str{
  my $time = shift;
  my ($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $isdst)
    = gmtime($time);

  my $wday_str = (Sun,Mon,Tue,Wed,Thu,Fri,Sat)[$wday];
  my $mon_str  = (Jan,Feb,Mar,Apr,May,Jun,Jul,Aug,Sep,Oct,Nov,Dec)[$mon];

  $str = sprintf("%s, %d %s %04d %02d:%02d:%02d GMT;",
		$wday_str, $mday, $mon_str, $year+1900, $hour, $min, $sec);

  return $str;

}

# $SET_COOKIE->{'KAME'} ˡ
# KAME Ȥ COOKIE(ͤ XXX)򡢻 time=1()򥻥åȤ롣
# Set-Cookie ֤ȡCookie ʤΤǡ
# ֥饦¸Ƥ Cookie KAME Ͼä롣
sub cookie_delete{
  $SET_COOKIE->{'KAME'} = &cookie_compose('KAME',"XXX",1,
					  $ENV{'SERVER_NAME'},
					  $ENV{'SCRIPT_NAME'} . "/");
  # cookie 
}


1;


