#!/usr/bin/perl

# $Id$

if (scalar(@ARGV) != 2){
  print scalar(@ARGV), "\n";
  &usage;
  exit;
}

#$LIST_ITEM="data";
#$TOP_DIR="/home/nkon/public_html/kame2";

$LIST_ITEM = $ARGV[0];
$TOP_DIR = $ARGV[1];

if (($LIST_ITEM ne 'data') and ($LIST_ITEM ne 'config')){
  print "<type> is 'data' or 'config'\n";
  &usage;
  exit;
}

if (! (-d $TOP_DIR)){
  print "<top_dir>=$TOP_DIR is not directory\n";
  &usage;
  exit;
}

open(PIPE, "find $TOP_DIR -print | ");
while(<PIPE>){
  $file = $_;
  chomp($file);

  next if ($file =~ /category\/user\/category\/\w+\/data\/session.db1$/);

  if ($file =~ /\/$LIST_ITEM\//){
    $file =~ s/^$TOP_DIR\///;
    print $file, "\n";
  }
}
close(PIPE);


sub usage{
  print "usage: list_data.pl <type> <top_dir>\n";
  print "       <type> is 'data' or 'config'\n";
  exit;
}
