#!/usr/bin/perl

# convert_.pl $B$N%F%9%H!#(B
# test_convert/*.pl $B$rFI$_9~$s$G!"$=$l$>$l$N7A<0$K$7$?$,$C$F%F%9%H$9$k!#(B


require '../kame-dat/package/convert/convert_.pl';
require '../kame-dat/syslib/sanitize_.pl';
require '../kame-dat/syslib/util.pl';

$INTERNAL = {};$SKEL = {};$INTERNAL_OK = {};$SKEL_OK = {};$DDKEY = "";

require './test_convert/textarea.pl';
require './test_convert/texthtml.pl';
require './test_convert/image.pl';

if ($GLOBAL_TEST_FAIL == 0){
  print "ALL TESTS IS SUCCEED!!\n";
} else {
  print "***TESTS FAIL\n";
}



sub test_convert_i2f{
  my $func = shift;
  my $test_fail = 0;
  my $key;

  my $str = " & $func ( \$DDKEY, \$SKEL, \$INTERNAL);";
  eval($str);
  foreach $key (keys %$SKEL_OK){
    if ($SKEL->{$key} eq $SKEL_OK->{$key}){
      ;
    } else {
      print "\n*** TEST FAIL($func) ***\n";
      print "Desired: \$SKEL_OK->{$key}=$SKEL_OK->{$key}\n";
      print "Ret    : \$SKEL->{$key}=$SKEL->{$key}\n";
      $GLOBAL_TEST_FAIL = 1;
    }
  }
}

sub test_convert_i2h{
  my $func = shift;
  my $test_fail = 0;
  my $key;

  my $str = " & $func ( \$DDKEY, \$SKEL, \$INTERNAL);";
  eval($str);
  foreach $key (keys %$SKEL_OK){
    if ($SKEL->{$key} eq $SKEL_OK->{$key}){
      ;
    } else {
      print "\n*** TEST FAIL($func) ***\n";
      print "Desired: \$SKEL_OK->{$key}=$SKEL_OK->{$key}\n";
      print "Ret    : \$SKEL->{$key}=$SKEL->{$key}\n";
      $GLOBAL_TEST_FAIL = 1;
    }
  }
}

sub test_convert_f2i{
  my $func = shift;
  my $test_fail = 0;
  my $key;

  my $ret;
  my $str = "\$ret = & $func ( \$DDKEY, \$PARAM);";
  eval($str);

  if ($ret eq $INTERNAL_OK->{$DDKEY}){
    ;
  } else {
    print "\n*** TEST FAIL($func) ***\n";
    print "Desired: \$INTERNAL_OK->{$DDKEY}=$INTERNAL_OK->{$DDKEY}\n";
    print "Ret    : \$ret=$ret\n";
    $GLOBAL_TEST_FAIL = 1;
  }
}

